

CREATE TABLE Bowler_Scores (

	MatchID INT NOT NULL,

	GameNumber INT NOT NULL,

	BowlerID INT NOT NULL,

	RawScore INT,

	HandiCapScore INT,

	WonGame INT )




CREATE TABLE Bowlers (

	BowlerID INT NOT NULL,

	BowlerLastName varchar(50) NOT NULL,

	BowlerFirstName varchar(50) NOT NULL,

	BowlerMiddleInit varchar(1) NULL,

	BowlerAddress varchar(50) NULL,

	BowlerCity varchar(50) NULL,

	BowlerState varchar(2) NULL,

	BowlerZip varchar(10) NULL,

	BowlerPhoneNumber varchar(14) NULL,

	TeamID INT 
)



CREATE TABLE Match_Games (

	MatchID INT NOT NULL,
	GameNumber INT NOT NULL,

	WinningTeamID INT NOT NULL
)



CREATE TABLE Teams (

	TeamID INT NOT NULL,

	TeamName varchar(50) NOT NULL,

	CaptainID INT NOT NULL 
)


CREATE TABLE Tournaments (

	TourneyID INT NOT NULL,

	TourneyDate datetime,

	TourneyLocation varchar(50)
)


CREATE TABLE Tourney_Matches (

	MatchID INT NOT NULL, 

	TourneyID INT NOT NULL,

	Lanes varchar(5) ,

	OddLaneTeamID INT NOT NULL,

	EvenLaneTeamID INT NOT NULL 
)


ALTER TABLE Bowler_Scores ADD
 
	CONSTRAINT Bowler_Scores_PK PRIMARY KEY
   
	(

		MatchID,

		GameNumber,

		BowlerID

	) 



CREATE  INDEX BowlerID ON Bowler_Scores(BowlerID) 



CREATE  INDEX MatchGamesBowlerScores ON Bowler_Scores(MatchID, GameNumber) 



ALTER TABLE Bowlers ADD
 
	CONSTRAINT Bowlers_PK PRIMARY KEY
   
	(

		BowlerID

	) 

CREATE  INDEX BowlerLastName ON Bowlers(BowlerLastName) 



CREATE  INDEX BowlersTeamID ON Bowlers(TeamID) 



ALTER TABLE Match_Games ADD
 
	CONSTRAINT Match_Games_PK PRIMARY KEY
   
	(

		MatchID,

		GameNumber

	) 



CREATE  INDEX Team1ID ON Match_Games(WinningTeamID) ;



CREATE  INDEX TourneyMatchesMatchGames ON Match_Games(MatchID) ;



ALTER TABLE Teams ADD 
	CONSTRAINT Teams_PK PRIMARY KEY
   
	(TeamID) 





ALTER TABLE Tournaments ADD
 
	CONSTRAINT Tournaments_PK PRIMARY KEY
   
	(TourneyID) 



ALTER TABLE Tourney_Matches ADD
 
	CONSTRAINT Tourney_Matches_PK PRIMARY KEY
   
	(MatchID) 



CREATE  INDEX Tourney_MatchesEven ON Tourney_Matches(EvenLaneTeamID) 



CREATE  INDEX TourneyMatchesOdd ON Tourney_Matches(OddLaneTeamID) 



CREATE  INDEX TourneyMatchesTourneyID ON Tourney_Matches(TourneyID) 



ALTER TABLE Bowler_Scores ADD
 
	CONSTRAINT Bowler_Scores_FK00 FOREIGN KEY
 
	(BowlerID) REFERENCES 
	Bowlers (

		BowlerID)


ALTER TABLE Bowler_Scores ADD
	CONSTRAINT Bowler_Scores_FK01 FOREIGN KEY
 
	(

		MatchID,

		GameNumber

	) REFERENCES Match_Games (

		MatchID,

		GameNumber

	)



ALTER TABLE Bowlers ADD
 
	CONSTRAINT Bowlers_FK00 FOREIGN KEY
 
	(

		TeamID

	) REFERENCES Teams (

		TeamID

	)



ALTER TABLE Match_Games ADD
 
	CONSTRAINT Match_Games_FK00 FOREIGN KEY
 
	(

		MatchID

	) REFERENCES Tourney_Matches (

		MatchID

	)



ALTER TABLE Tourney_Matches ADD
 
	CONSTRAINT Tourney_Matches_FK00 FOREIGN KEY
 
	(

		EvenLaneTeamID

	) REFERENCES Teams (

		TeamID

	)

ALTER TABLE Tourney_Matches ADD

	CONSTRAINT Tourney_Matches_FK01 FOREIGN KEY
 
	(

		OddLaneTeamID

	) REFERENCES Teams (

		TeamID

	)

ALTER TABLE Tourney_Matches ADD

	CONSTRAINT Tourney_Matches_FK02 FOREIGN KEY
 
	(

		TourneyID

	) REFERENCES Tournaments (

		TourneyID

	)